"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const classnames_1 = tslib_1.__importDefault(require("classnames"));
const xor_1 = tslib_1.__importDefault(require("lodash/xor"));
const react_1 = tslib_1.__importDefault(require("react"));
const uniforms_1 = require("uniforms");
const base64 = typeof btoa === 'undefined'
    ? /* istanbul ignore next */ /* istanbul ignore next */ x => Buffer.from(x).toString('base64')
    : btoa;
const escape = (x) => base64(encodeURIComponent(x)).replace(/=+$/, '');
const selectStyle = { paddingBottom: 0, paddingTop: 0 };
function Select(_a) {
    var { allowedValues, checkboxes, className, disableItem, disabled, error, errorMessage, fieldType, id, inputRef, label, name, onChange, placeholder, readOnly, required, showInlineError, transform, value } = _a, props = tslib_1.__rest(_a, ["allowedValues", "checkboxes", "className", "disableItem", "disabled", "error", "errorMessage", "fieldType", "id", "inputRef", "label", "name", "onChange", "placeholder", "readOnly", "required", "showInlineError", "transform", "value"]);
    const multiple = fieldType === Array;
    return (react_1.default.createElement("div", Object.assign({ className: classnames_1.default({ disabled, error, required }, className, 'field') }, uniforms_1.filterDOMProps(props)),
        label && react_1.default.createElement("label", { htmlFor: id }, label),
        checkboxes ? (allowedValues === null || allowedValues === void 0 ? void 0 : allowedValues.map(item => (react_1.default.createElement("div", { className: "field", key: item },
            react_1.default.createElement("div", { className: "ui checkbox" },
                react_1.default.createElement("input", { checked: multiple ? value === null || value === void 0 ? void 0 : value.includes(item) : value === item, disabled: (disableItem === null || disableItem === void 0 ? void 0 : disableItem(item)) || disabled, id: `${id}-${escape(item)}`, name: name, onChange: () => {
                        if (!readOnly) {
                            onChange(multiple ? xor_1.default([item], value) : item);
                        }
                    }, type: "checkbox" }),
                react_1.default.createElement("label", { htmlFor: `${id}-${escape(item)}` }, transform ? transform(item) : item)))))) : (react_1.default.createElement("select", { className: "ui selection dropdown", disabled: disabled, id: id, multiple: multiple, name: name, onChange: event => {
                if (!readOnly) {
                    const item = event.target.value;
                    if (multiple) {
                        const clear = event.target.selectedIndex === -1;
                        onChange(clear ? [] : xor_1.default([item], value));
                    }
                    else {
                        onChange(item !== '' ? item : undefined);
                    }
                }
            }, ref: inputRef, style: selectStyle, value: value !== null && value !== void 0 ? value : '' },
            (!!placeholder || !required || value === undefined) && !multiple && (react_1.default.createElement("option", { value: "", disabled: required, hidden: required }, placeholder || label)), allowedValues === null || allowedValues === void 0 ? void 0 :
            allowedValues.map(value => (react_1.default.createElement("option", { disabled: disableItem === null || disableItem === void 0 ? void 0 : disableItem(value), key: value, value: value }, transform ? transform(value) : value))))),
        !!(error && showInlineError) && (react_1.default.createElement("div", { className: "ui red basic pointing label" }, errorMessage))));
}
exports.default = uniforms_1.connectField(Select, { kind: 'leaf' });
