import { __rest } from "tslib";
import classnames from 'classnames';
import omit from 'lodash/omit';
import React from 'react';
import { connectField, filterDOMProps } from 'uniforms';
const base64 = typeof btoa === 'undefined'
    ? /* istanbul ignore next */ /* istanbul ignore next */ x => Buffer.from(x).toString('base64')
    : btoa;
const escape = (x) => base64(encodeURIComponent(x)).replace(/=+$/, '');
function Radio(_a) {
    var { allowedValues, className, disabled, error, errorMessage, id, label, name, onChange, readOnly, required, showInlineError, transform, value } = _a, props = __rest(_a, ["allowedValues", "className", "disabled", "error", "errorMessage", "id", "label", "name", "onChange", "readOnly", "required", "showInlineError", "transform", "value"]);
    return (React.createElement("div", Object.assign({ className: classnames(className, { disabled, error }, 'grouped fields') }, omit(filterDOMProps(props), ['checkboxes'])),
        label && (React.createElement("div", { className: classnames({ required }, 'field') },
            React.createElement("label", null, label))), allowedValues === null || allowedValues === void 0 ? void 0 :
        allowedValues.map(item => (React.createElement("div", { className: "field", key: item },
            React.createElement("div", { className: "ui radio checkbox" },
                React.createElement("input", { checked: item === value, disabled: disabled, id: `${id}-${escape(item)}`, name: name, onChange: () => {
                        if (!readOnly) {
                            onChange(item);
                        }
                    }, type: "radio" }),
                React.createElement("label", { htmlFor: `${id}-${escape(item)}` }, transform ? transform(item) : item))))),
        !!(error && showInlineError) && (React.createElement("div", { className: "ui red basic pointing label" }, errorMessage))));
}
export default connectField(Radio, { kind: 'leaf' });
