import { __rest } from "tslib";
import classnames from 'classnames';
import xor from 'lodash/xor';
import React from 'react';
import { connectField, filterDOMProps } from 'uniforms';
const base64 = typeof btoa === 'undefined'
    ? /* istanbul ignore next */ /* istanbul ignore next */ x => Buffer.from(x).toString('base64')
    : btoa;
const escape = (x) => base64(encodeURIComponent(x)).replace(/=+$/, '');
const selectStyle = { paddingBottom: 0, paddingTop: 0 };
function Select(_a) {
    var { allowedValues, checkboxes, className, disableItem, disabled, error, errorMessage, fieldType, id, inputRef, label, name, onChange, placeholder, readOnly, required, showInlineError, transform, value } = _a, props = __rest(_a, ["allowedValues", "checkboxes", "className", "disableItem", "disabled", "error", "errorMessage", "fieldType", "id", "inputRef", "label", "name", "onChange", "placeholder", "readOnly", "required", "showInlineError", "transform", "value"]);
    const multiple = fieldType === Array;
    return (React.createElement("div", Object.assign({ className: classnames({ disabled, error, required }, className, 'field') }, filterDOMProps(props)),
        label && React.createElement("label", { htmlFor: id }, label),
        checkboxes ? (allowedValues === null || allowedValues === void 0 ? void 0 : allowedValues.map(item => (React.createElement("div", { className: "field", key: item },
            React.createElement("div", { className: "ui checkbox" },
                React.createElement("input", { checked: multiple ? value === null || value === void 0 ? void 0 : value.includes(item) : value === item, disabled: (disableItem === null || disableItem === void 0 ? void 0 : disableItem(item)) || disabled, id: `${id}-${escape(item)}`, name: name, onChange: () => {
                        if (!readOnly) {
                            onChange(multiple ? xor([item], value) : item);
                        }
                    }, type: "checkbox" }),
                React.createElement("label", { htmlFor: `${id}-${escape(item)}` }, transform ? transform(item) : item)))))) : (React.createElement("select", { className: "ui selection dropdown", disabled: disabled, id: id, multiple: multiple, name: name, onChange: event => {
                if (!readOnly) {
                    const item = event.target.value;
                    if (multiple) {
                        const clear = event.target.selectedIndex === -1;
                        onChange(clear ? [] : xor([item], value));
                    }
                    else {
                        onChange(item !== '' ? item : undefined);
                    }
                }
            }, ref: inputRef, style: selectStyle, value: value !== null && value !== void 0 ? value : '' },
            (!!placeholder || !required || value === undefined) && !multiple && (React.createElement("option", { value: "", disabled: required, hidden: required }, placeholder || label)), allowedValues === null || allowedValues === void 0 ? void 0 :
            allowedValues.map(value => (React.createElement("option", { disabled: disableItem === null || disableItem === void 0 ? void 0 : disableItem(value), key: value, value: value }, transform ? transform(value) : value))))),
        !!(error && showInlineError) && (React.createElement("div", { className: "ui red basic pointing label" }, errorMessage))));
}
export default connectField(Select, { kind: 'leaf' });
